
#include "ExternalCall.h"
#include "limits.h"

namespace nanojit
{
namespace interpreter
{


template<typename T>
inline void doExternalCall0(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	NanoUnusedVariable(a_pContext);

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)();
	};

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function();
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0>
inline void doExternalCall1(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0);
	};

	T0 p0 = a_pContext->getStack<T0>(0);


	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function(p0);
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0, typename T1>
inline void doExternalCall2(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0, T1);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res =  oConverter.function(p0, p1);
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0, typename T1, typename T2>
inline void doExternalCall3(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0, T1, T2);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function(p0, p1, p2);
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0, typename T1, typename T2, typename T3>
inline void doExternalCall4(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0, T1, T2, T3);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function(p0, p1, p2, p3);
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0, typename T1, typename T2, typename T3, typename T4>
inline void doExternalCall5(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0, T1, T2, T3, T4);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function(p0, p1, p2, p3, p4);
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5>
inline void doExternalCall6(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0, T1, T2, T3, T4, T5);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);
	T5 p5 = a_pContext->getStack<T5>(5);


	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function(p0, p1, p2, p3, p4, p5);
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
inline void doExternalCall7(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0, T1, T2, T3, T4, T5, T6);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);
	T5 p5 = a_pContext->getStack<T5>(5);
	T6 p6 = a_pContext->getStack<T6>(6);


	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function(p0, p1, p2, p3, p4, p5, p6);
	a_pContext->set<T>(resultReg, res);
}

template<typename T, typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7>
inline void doExternalCall8(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg) {

	union CallbackConverter {
		uintptr_t	callAddress;
		T			(*function)(T0, T1, T2, T3, T4, T5, T6, T7);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);
	T5 p5 = a_pContext->getStack<T5>(5);
	T6 p6 = a_pContext->getStack<T6>(6);
	T7 p7 = a_pContext->getStack<T7>(7);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	T res = oConverter.function(p0, p1, p2, p3, p4, p5, p6, p7);
	a_pContext->set<T>(resultReg, res);
}

// void calls

inline void doVoidExternalCall0(IntepreterContext* a_pContext, uintptr_t callAddress) {

	NanoUnusedVariable(a_pContext);

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)();
	};

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function();
}

template<typename T0>
inline void doVoidExternalCall1(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0);
	};

	T0 p0 = a_pContext->getStack<T0>(0);


	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0);
}

template<typename T0, typename T1>
inline void doVoidExternalCall2(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0, T1);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0, p1);
}

template<typename T0, typename T1, typename T2>
inline void doVoidExternalCall3(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0, T1, T2);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0, p1, p2);
}

template<typename T0, typename T1, typename T2, typename T3>
inline void doVoidExternalCall4(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0, T1, T2, T3);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0, p1, p2, p3);
}

template<typename T0, typename T1, typename T2, typename T3, typename T4>
inline void doVoidExternalCall5(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0, T1, T2, T3, T4);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0, p1, p2, p3, p4);
}

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5>
inline void doVoidExternalCall6(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0, T1, T2, T3, T4, T5);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);
	T5 p5 = a_pContext->getStack<T5>(5);


	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0, p1, p2, p3, p4, p5);
}

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6>
inline void doVoidExternalCall7(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0, T1, T2, T3, T4, T5, T6);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);
	T5 p5 = a_pContext->getStack<T5>(5);
	T6 p6 = a_pContext->getStack<T6>(6);


	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0, p1, p2, p3, p4, p5, p6);
}

template<typename T0, typename T1, typename T2, typename T3, typename T4, typename T5, typename T6, typename T7>
inline void doVoidExternalCall8(IntepreterContext* a_pContext, uintptr_t callAddress) {

	union CallbackConverter {
		uintptr_t	callAddress;
		void		(*function)(T0, T1, T2, T3, T4, T5, T6, T7);
	};

	T0 p0 = a_pContext->getStack<T0>(0);
	T1 p1 = a_pContext->getStack<T1>(1);
	T2 p2 = a_pContext->getStack<T2>(2);
	T3 p3 = a_pContext->getStack<T3>(3);
	T4 p4 = a_pContext->getStack<T4>(4);
	T5 p5 = a_pContext->getStack<T5>(5);
	T6 p6 = a_pContext->getStack<T6>(6);
	T7 p7 = a_pContext->getStack<T7>(7);

	CallbackConverter oConverter;
	oConverter.callAddress = callAddress;
	oConverter.function(p0, p1, p2, p3, p4, p5, p6, p7);
}

// should probably be auto generated
void doExternalCallFromSignature(IntepreterContext* context, uintptr_t callAddress, unsigned int resultReg, CallSignature signature) {

	NanoUnusedVariable(resultReg);

	switch (signature) {

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_0(LTy_V):
		doVoidExternalCall0(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_1(LTy_V, LTy_I):
		doVoidExternalCall1<uint32_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_2(LTy_V, LTy_I, LTy_I):
		doVoidExternalCall2<uint32_t, uint32_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_3(LTy_V, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall3<uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_4(LTy_V, LTy_I, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall4<uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_5(LTy_V, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall5<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_6(LTy_V, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall6<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_7(LTy_V, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall7<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	case MAKE_CALL_SIGNATURE_8(LTy_V, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall8<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	//
	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_0(LTy_I):
		doExternalCall0<uint32_t>(context, callAddress, resultReg);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_1(LTy_I, LTy_I):
		doExternalCall1<uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_2(LTy_I, LTy_I, LTy_I):
		doExternalCall2<uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_3(LTy_I, LTy_I, LTy_I, LTy_I):
		doExternalCall3<uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_4(LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doExternalCall4<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_5(LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doExternalCall5<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_6(LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doExternalCall6<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_7(LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doExternalCall7<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	case MAKE_CALL_SIGNATURE_8(LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doExternalCall8<uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

#if defined(NANOJIT_64BIT)

	// 
	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_1(LTy_I, LTy_Q):
		doExternalCall1<uint32_t, uint64_t>(context, callAddress, resultReg);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_3(LTy_I, LTy_Q, LTy_I, LTy_I):
		doExternalCall3<uint32_t, uint64_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	//
	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_1(LTy_V, LTy_Q):
		doVoidExternalCall1<uint64_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_4(LTy_V, LTy_Q, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall4<uint64_t, uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_2(LTy_V, LTy_I, LTy_Q):
		doVoidExternalCall2<uint32_t, uint64_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_2(LTy_V, LTy_Q, LTy_Q):
		doVoidExternalCall2<uint64_t, uint64_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_2(LTy_V, LTy_Q, LTy_I):
		doVoidExternalCall2<uint64_t, uint32_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_3(LTy_V, LTy_Q, LTy_I, LTy_I):
		doVoidExternalCall3<uint64_t, uint32_t, uint32_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_5(LTy_V, LTy_Q, LTy_I, LTy_I, LTy_I, LTy_Q):
		doVoidExternalCall5<uint64_t, uint32_t, uint32_t, uint32_t, uint64_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_7(LTy_V, LTy_Q, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doVoidExternalCall7<uint64_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress);
		break;

	//
	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_1(LTy_Q, LTy_I):
		doExternalCall1<uint64_t, uint32_t>(context, callAddress, resultReg);
		break;

	//
	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_4(LTy_Q, LTy_Q, LTy_I, LTy_I, LTy_I):
		doExternalCall4<uint64_t, uint64_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

	//
	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_2(LTy_I, LTy_Q, LTy_I):
		doExternalCall2<uint32_t, uint64_t, uint32_t>(context, callAddress, resultReg);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_6(LTy_I, LTy_Q, LTy_I, LTy_I, LTy_I, LTy_I, LTy_I):
		doExternalCall6<uint32_t, uint64_t, uint32_t, uint32_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;

		//
	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_4(LTy_V, LTy_I, LTy_I, LTy_I, LTy_Q):
		doVoidExternalCall4<uint32_t, uint32_t, uint32_t, uint64_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_5(LTy_V, LTy_I, LTy_I, LTy_I, LTy_I, LTy_Q):
		doVoidExternalCall5<uint32_t, uint32_t, uint32_t, uint32_t, uint64_t>(context, callAddress);
		break;

	case NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_4(LTy_I, LTy_Q, LTy_I, LTy_I, LTy_I):
		doExternalCall4<uint32_t, uint64_t, uint32_t, uint32_t, uint32_t>(context, callAddress, resultReg);
		break;


#endif // defined(NANOJIT_64BIT)

	default:
		NanoAssert(0); // unsupported signature
		break;

	}
}

CallSignature createFunctionSignature(LIns* callIns, const ParameterValue* callParams, unsigned int paramCount) {

	LTy				type;
	uint64_t		signature = 0;
	unsigned int	shiftCount = 3;

	// 3 bits for each type, max 20 parameters + return value
	NanoAssert((paramCount + 1) < ((sizeof(uint64_t) * CHAR_BIT) / 3));

	type = callIns->retType();
	NanoAssert(type < 7);
	signature = (type + 1);

	for (unsigned int paramIndex = 0; paramIndex < paramCount; ++paramIndex) {
		const ParameterValue* param = &callParams[paramIndex];
		LTy type = param->value->retType();
		NanoAssert(type < (1 << NANOJIT_INTERPRETER_CALL_SIGNATURE_PARAM_SHIFT));
		signature |= static_cast<uint64_t>(type + 1) << shiftCount;

		shiftCount += NANOJIT_INTERPRETER_CALL_SIGNATURE_PARAM_SHIFT;
	}

	return signature;
}


} // namespace interpreter
} // namespace nanojit
