

#include <NativeInterpreterTypes.h>

#define NANOJIT_INTERPRETER_CALL_SIGNATURE_PARAM_SHIFT 3

#define NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_0(retType)																							\
	(CallSignature)((retType + 1))

#define NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_1(retType, param0Type)																				\
	(	NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_0(retType)																							\
	|	((CallSignature)(((param0Type) + 1)) << NANOJIT_INTERPRETER_CALL_SIGNATURE_PARAM_SHIFT))

#define NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_2(retType, param0Type, param1Type)																	\
	(	NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_1(retType, param0Type)																				\
	|	((CallSignature)(((param1Type) + 1)) << (NANOJIT_INTERPRETER_CALL_SIGNATURE_PARAM_SHIFT * 2)))

#define NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_3(retType, param0Type, param1Type, param2Type)														\
	(	NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_2(retType, param0Type, param1Type)																	\
	|	((CallSignature)(((param2Type) + 1)) << (NANOJIT_INTERPRETER_CALL_SIGNATURE_PARAM_SHIFT * 3)))

#define NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_4(retType, param0Type, param1Type, param2Type, param3Type)											\
	(	NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_3(retType, param0Type, param1Type, param2Type)														\
	|	((CallSignature)(((param3Type) + 1)) << (NANOJIT_INTERPRETER_CALL_SIGNATURE_PARAM_SHIFT * 4)))

#define NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_5(retType, param0Type, param1Type, param2Type, param3Type, param4Type)								\
	(	NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_4(retType, param0Type, param1Type, param2Type, param3Type)											\
	|	((CallSignature)(((param4Type) + 1)) << (NANOJIT_INTERPRETER_CALL_SIGNATURE_PARAM_SHIFT * 5)))

#define NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_6(retType, param0Type, param1Type, param2Type, param3Type, param4Type, param5Type)					\
	(	NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_5(retType, param0Type, param1Type, param2Type, param3Type, param4Type)								\
	|	((CallSignature)(((param5Type) + 1)) << (NANOJIT_INTERPRETER_CALL_SIGNATURE_PARAM_SHIFT * 6)))

#define NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_7(retType, param0Type, param1Type, param2Type, param3Type, param4Type, param5Type, param6Type)		\
	(	NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_6(retType, param0Type, param1Type, param2Type, param3Type, param4Type, param5Type)					\
	|	((CallSignature)(((param6Type) + 1)) << (NANOJIT_INTERPRETER_CALL_SIGNATURE_PARAM_SHIFT * 7)))

#define MAKE_CALL_SIGNATURE_8(retType, param0Type, param1Type, param2Type, param3Type, param4Type, param5Type, param6Type, param7Type)				\
	(	NANOJIT_INTERPRETER_MAKE_CALL_SIGNATURE_7(retType, param0Type, param1Type, param2Type, param3Type, param4Type, param5Type, param6Type)		\
	|	((CallSignature)(((param7Type) + 1)) << (NANOJIT_INTERPRETER_CALL_SIGNATURE_PARAM_SHIFT * 8)))


namespace nanojit
{
namespace interpreter
{

typedef uint64_t CallSignature;

void doExternalCallFromSignature(IntepreterContext* a_pContext, uintptr_t callAddress, unsigned int resultReg, CallSignature signature);
CallSignature createFunctionSignature(LIns* callIns, const ParameterValue* callParams, unsigned int paramCount);


} // namespace interpreter
} // namespace nanojit


