
#include "nanojit.h"

#include <stdarg.h>

#if defined(WIN32)
#include <Windows.h>
#endif
#include <stdio.h>

namespace nanojit
{
namespace debug
{

void Log(const char* a_sMessage, ...) {

	va_list vl;
	va_start(vl, a_sMessage);
	vprintf(a_sMessage, vl);
	va_end(vl);
}

void AssertFail(const char* a_sMessage) {

	if ((a_sMessage != NULL) && (VMPI_strlen(a_sMessage) > 0)) {
		printf("%s", a_sMessage);
	}

	fflush(NULL);

	Break();
}

void Break() {
#if defined(WIN32)
	fflush(NULL);
	::DebugBreak();
#else
	*(volatile int*)0 = 0;
#endif
}

} // namespace debug
} // namespace nanojit
