
#ifndef __nanojit_PeepholeMacher__
#define __nanojit_PeepholeMacher__

#include "nanojit.h"

namespace nanojit
{

class PeepholeMacher
{
public:
	static const uint32_t								MATCH_FAILED = 0xFFFFFFFF;

private:
	typedef PodVector<Pair<const LOpcode*, uint32_t> >	TreeVector;
	TreeVector**										opcodeTreeVector;
	Allocator*											allocator;

public:
							PeepholeMacher();
							~PeepholeMacher();

	void					initialize(Allocator* allocator);
	void					shutdown();

	void					addPersistantTree(const LOpcode* tree, size_t count, uint32_t value);

	uint32_t				match(LIns* ins);

private:
	static const LOpcode*	matchTree(LIns* ins, const LOpcode* tree);
};

}

#endif // ifndef __nanojit_PeepholeMacher__

